/*
 * PROJECT C Library, X68000 PROGRAMMING INTERFACE DEFINITION
 * --------------------------------------------------------------------
 * This file is written by the Project C Library Group,  and completely
 * in public domain. You can freely use, copy, modify, and redistribute
 * the whole contents, without this notice.
 * --------------------------------------------------------------------
 * $Id: sprintf.c,v 1.1.1.1 1993/04/18 16:23:16 mura Exp $
 */

/* System headers */
#include <stdio.h>
#include <stdarg.h>
#include <sys/xstdio.h>

/* Functions */
int snprintf (char *buffer, size_t n, const char *format, ...)
{
    int cnt;
    va_list ap;
    struct _stdbuf string;

	if ((int)n < 1)
		return (EOF);

    /* obt@ FILE \̂ɍv */
    string._ptr = string._base = (unsigned char *) buffer;
    string._cnt = string._bufsiz = n - 1;
    string._flag = _IOWRITE | _IOW | _IOBIN;
    string._file = -1;
    string._nback = 0;

    /* tH[}bgo */
    va_start (ap, format);
    cnt = _doprnt (format, ap, &string);
    va_end (ap);

    /* nullőł~ */
    buffer[cnt] = '\0';
    return cnt;
}
